%esercizio 2
%Scrivere una function steepest.m che implementi il metodo visto a lezione.
function [fmin,xmin] = steepest(fun,grad,init,step,a,b,c,d,itermax,tol)

xmin=init;
gradmin=grad(xmin(1),xmin(2));
conv=false;         
i=0;                

while(i<itermax && ~conv)
   x1=xmin-step*gradmin;
   while(fun(xmin(1),xmin(2))<fun(x1(1),x1(2)) || ~(a<=x1(1)<=b && c<=x1(1)<=d))
       step=step/2;
       x1=xmin-step*gradmin;
       i=i+1;
   end
   gradmin=grad(x1(1),x1(2));
   xmin=x1;
   i=i+1;
end

%L'iterazione si arresta se la norma del gradiente è minore di tol(convergenza)
if(norm(gradmin)<tol) 
    fmin=fun(xmin(1),xmin(2));
    disp('Converge!');
%Oppure l'iterazione si arresta se il numero di iterazioni eseguite è maggiore di itermax (fallimento)
else
    disp('Iterazione fallita');
end