%script esercizio 2
%Scrivere uno script che applichi la function steepest alla funzione f(x,y)= x^2/2 + 2y^2 su [−2,2] ×[−2,2] 
%e crei due figure: 
% figura (1) contiene il grafico di f (cio`e una superficie in R3) 
% figura (2) in cui sono disegnate le curve di livello di f insieme al percorso seguito dal metodo.

%funzione
f = @(x,y) (x.^2)/2 + 2*(y.^2);

%handle al gradiente della funzione da minimizzare
grad = @(x,y) [x,4*y];

%vettore di lunghezza 2 contenente le coordinate del punto iniziale
init = 2 * [rand(1), rand(1)];

%numero reale positivo corrispondente alla lunghezza del passo iniziale
step = 0.1;

%estremi della “finestra” in cui si cerca il minimo 
a = -2 ;
b = 2;
c = a; 
d = b;

%numero massimo di iterazioni
itermax=2000;

%tolleranza sulla norma del gradiente, da usare come criterio di convergenza
tol=10^-4;

[fmin, xmin]=steepest(f, grad, init, step, a, b, c, d, itermax, tol);

%genera 100 valori equispaziati fra -2 e 2 compresi.
x=linspace(-2,2,100);
y=x;

%Le funzioni mesh e surf visualizzano le superfici in modalità tridimensionale
[X,Y]=meshgrid(x,y);
S=f(X,Y);
surf(X,Y,S)

% Permette di tracciare più grafici su più finestre 
figure()

%traccia il grafico bidimensionale
contour(X,Y,S)